#!/bin/bash
#set -x
#
# Script: screenwebcast.sh
# Author: Heiko@wurst-wasser.net
# Copyright: Heiko Kretschmer (c) 2007-2010
# Purpose: Macht Screenshots des Rechners und legt sie in das Public-Site-Verzeichnis, wo es bei
#          aktiviertem Webdienst von allen gesehen werden kann. Koscht nix, isch praktisch.
#
# History: 
# 2007-10-15, 17:17, hk: Done.
#             17:42, hk: Cache-Problem geloest, Bildname wird staendig upgedatet.
# 2008-01-01, 22:55, hk: Minor change, Variable für ScreenCapture-App, sowie Erst Folder erstellen, dann capturen.
# 2008-01-10, 10:00, hk: Refresh-Intervall parametrisierbar.
#                        Footer mit Date, Datevariablen aufgeräumt.
#             11:10, hk: Userpfad aus env holen, weil sonst bei root nicht geht. Rechte auf ~ setzen. Nur bei root nötig. Sollte kein Risiko sein, oder?
#
#
# ToDo:
# -keep and display history of images
#

#touch /Users/heiko/Desktop/tescht.txt
#exit

GDATE="`date +'%Y-%m-%d'`"
GTIME="`date +'%H:%M:%S'`"
GDATEFULL="${GDATE} ${GTIME}"
GDATESHORT="${GDATE}-${GTIME}"
GNAMEHOST="`hostname`"
GNAMEUSER="`whoami | head -1`"
GNAMEIMAGEFOLDER="ScreenWebCastImages"
GFOLDERWEB="${HOME}/Sites"
#GFOLDERWEB="/Users/${GNAMEUSER}/Sites"
GFOLDERWEBIMAGES="${GFOLDERWEB}/${GNAMEIMAGEFOLDER}"
GNAMEIMAGE="screenwebcast-${GDATESHORT}.jpg"
GFILEIMAGE=${GFOLDERWEBIMAGES}/${GNAMEIMAGE}
GFILEINDEX="${GFOLDERWEB}/index.html"
GAPPSCREENCAPTURE="/usr/sbin/screencapture"
GRELOADINTERVAL="${1}"

# Falls der Siteordner noch nicht existiert: Anlegen! (Das kann bei ~root vorkommen)
test ! -d "${GFOLDERWEB}" && mkdir "${GFOLDERWEB}" && chmod 755 "${GFOLDERWEB}" && chmod o+rx "${HOME}"

# Falls der Bilderordner noch nicht existiert: Anlegen!
test ! -d "${GFOLDERWEBIMAGES}" && mkdir "${GFOLDERWEBIMAGES}" && chmod o+rx "${GFOLDERWEBIMAGES}"

# Falls der Interval fehlt
test -z "${GRELOADINTERVAL}" && GRELOADINTERVAL="30"

# Screenshot machen
${GAPPSCREENCAPTURE} -m -x -tjpg "${GFILEIMAGE}"

# Alten Screenshot wegwerfen (spaeter mal fuer Archiv aufheben, jetzt aber weg damit, wegen Plattenplatz-Risiko)
find "${GFOLDERWEBIMAGES}" -type f | grep -v "${GFILEIMAGE}" | while read OLDFILE; do
     #echo "Loesche ${OLDFILE}"
     rm "${OLDFILE}"
done

# Footer zusammenbauen
HTMLFOOTER="<i>This page was built ${GDATE} at ${GTIME} with interval ${GRELOADINTERVAL}</i>"

# Index.html aufbauen
echo "<HTML> <HEAD> <META HTTP-EQUIV=\"content-type\" CONTENT=\"text/html; charset=windows-1252\">" > "${GFILEINDEX}"
echo "<META http-equiv=\"pragma\" content=\"no-cache\"> <META http-equiv=\"refresh\" content=\"${GRELOADINTERVAL};URL=index.html\">" >> "${GFILEINDEX}"
echo "<TITLE>${GNAMEUSER} @ ${GNAMEHOST} ScreenWebCast (${GDATEFULL})</TITLE> </HEAD>" >> "${GFILEINDEX}"
echo "<BODY BGCOLOR=#FFFFFF> <CENTER>" >> "${GFILEINDEX}"
echo "<IMG SRC=\"./${GNAMEIMAGEFOLDER}/${GNAMEIMAGE}\">" >> "${GFILEINDEX}"
echo "</CENTER>" >> "${GFILEINDEX}"
echo "${HTMLFOOTER}" >> "${GFILEINDEX}"
echo "</BODY> </HTML>" >> "${GFILEINDEX}"
